﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FlexgridComboBox_TypeConverter
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
       
      //Initialize enum combo:
      this.comboBox1.CreateItems();
      //Set selected Item:
      this.comboBox1.SelectedItem = MyGreatEnum.GreatValue;

      //Init combobox columns:
      this.c1FlexGrid1.Cols[1].DataType = typeof(System.Drawing.KnownColor);
      this.c1FlexGrid1.Cols[2].DataType = typeof(MyGreatEnum);

      for (int intRow = this.c1FlexGrid1.Rows.Fixed; intRow < this.c1FlexGrid1.Rows.Count; intRow++)
      {
        this.c1FlexGrid1[intRow, 1] = KnownColor.Blue;
        this.c1FlexGrid1[intRow, 2] = MyGreatEnum.GreatValue;
      }
    }

    //customize the combo to show converted values
    private void c1FlexGrid1_SetupEditor(object sender, C1.Win.C1FlexGrid.RowColEventArgs e)
    {
        if (e.Col == 2)
        {
            //Enum-Combo-Column:

            ComboBox combo = (ComboBox)this.c1FlexGrid1.Editor;

            combo.DrawMode = DrawMode.Normal;
            combo.FormattingEnabled = true;
            //Apply cell data to selected item - Method 1
           // combo.SelectedItem = (MyGreatEnum)this.c1FlexGrid1[e.Row, e.Col];

        }
    }

    private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
    {
      this.label5.Text = this.comboBox1.SelectedItem.ToString();
    }

    private void GetCellValueBtn_Click(object sender, EventArgs e)
    {
        MessageBox.Show(this, "Value of cell " + this.c1FlexGrid1.Row + "/" + this.c1FlexGrid1.Col + ": " + this.c1FlexGrid1[this.c1FlexGrid1.Row, this.c1FlexGrid1.Col]);
    }

    // undo changes when editor closes - Method 2
    private void c1FlexGrid1_LeaveEdit(object sender, C1.Win.C1FlexGrid.RowColEventArgs e)
    {
        var combo = this.c1FlexGrid1.Editor as ComboBox;
        if (combo != null)
        {
            combo.FormattingEnabled = false;
            combo.DrawMode = DrawMode.OwnerDrawVariable;
        }
    }

  }
}
